/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the YoutubeVideoConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &YoutubeVideoConnectorForm{}

// YoutubeVideoConnectorForm struct for YoutubeVideoConnectorForm
type YoutubeVideoConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId string `json:"oAuthId"`
	// Data source label
	Label string `json:"label"`
	// Your channel id
	ChannelId string `json:"channelId"`
	// Your playlist id
	PlaylistId string `json:"playlistId"`
	// YT attributes
	Attribute []string `json:"attribute"`
}

// NewYoutubeVideoConnectorForm instantiates a new YoutubeVideoConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewYoutubeVideoConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, channelId string, playlistId string, attribute []string) *YoutubeVideoConnectorForm {
	this := YoutubeVideoConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.ChannelId = channelId
	this.PlaylistId = playlistId
	this.Attribute = attribute
	return &this
}

// NewYoutubeVideoConnectorFormWithDefaults instantiates a new YoutubeVideoConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewYoutubeVideoConnectorFormWithDefaults() *YoutubeVideoConnectorForm {
	this := YoutubeVideoConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *YoutubeVideoConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *YoutubeVideoConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *YoutubeVideoConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *YoutubeVideoConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *YoutubeVideoConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *YoutubeVideoConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *YoutubeVideoConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *YoutubeVideoConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *YoutubeVideoConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *YoutubeVideoConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *YoutubeVideoConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *YoutubeVideoConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *YoutubeVideoConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetChannelId returns the ChannelId field value
func (o *YoutubeVideoConnectorForm) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *YoutubeVideoConnectorForm) SetChannelId(v string) {
	o.ChannelId = v
}

// GetPlaylistId returns the PlaylistId field value
func (o *YoutubeVideoConnectorForm) GetPlaylistId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PlaylistId
}

// GetPlaylistIdOk returns a tuple with the PlaylistId field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetPlaylistIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PlaylistId, true
}

// SetPlaylistId sets field value
func (o *YoutubeVideoConnectorForm) SetPlaylistId(v string) {
	o.PlaylistId = v
}

// GetAttribute returns the Attribute field value
func (o *YoutubeVideoConnectorForm) GetAttribute() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value
// and a boolean to check if the value has been set.
func (o *YoutubeVideoConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attribute, true
}

// SetAttribute sets field value
func (o *YoutubeVideoConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

func (o YoutubeVideoConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o YoutubeVideoConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["channelId"] = o.ChannelId
	toSerialize["playlistId"] = o.PlaylistId
	toSerialize["attribute"] = o.Attribute
	return toSerialize, nil
}

type NullableYoutubeVideoConnectorForm struct {
	value *YoutubeVideoConnectorForm
	isSet bool
}

func (v NullableYoutubeVideoConnectorForm) Get() *YoutubeVideoConnectorForm {
	return v.value
}

func (v *NullableYoutubeVideoConnectorForm) Set(val *YoutubeVideoConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableYoutubeVideoConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableYoutubeVideoConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableYoutubeVideoConnectorForm(val *YoutubeVideoConnectorForm) *NullableYoutubeVideoConnectorForm {
	return &NullableYoutubeVideoConnectorForm{value: val, isSet: true}
}

func (v NullableYoutubeVideoConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableYoutubeVideoConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
